Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -5896,36 +5669,36 @@
 ! !
 ! !--          Obtain indices
-!              i = surf_usm_v(l)%i(m)
-!              j = surf_usm_v(l)%j(m)
-!              k = surf_usm_v(l)%k(m)
-!
-!              t_green_v(l)%t(nzt_wall+1,m) = t_wall_v(l)%t(nzb_wall,m)
+!              i = surf%i(m)
+!              j = surf%j(m)
+!              k = surf%k(m)
+!
+!              t_green%val(nzt_wall+1,m) = t_wall%val(nzb_wall,m)
 ! !
 ! !--          Prognostic equation for green temperature t_green_v
 !              gtend(:) = 0.0_wp
-!              gtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_green(nzb_wall,m)) * &
-!                                      ( surf_usm_v(l)%lambda_h_green(nzb_wall,m) * &
-!                                        ( t_green_v(l)%t(nzb_wall+1,m)             &
-!                                        - t_green_v(l)%t(nzb_wall,m) ) *           &
-!                                        surf_usm_v(l)%ddz_green(nzb_wall+1,m)      &
-!                                      + surf_usm_v(l)%wghf_eb(m) ) *               &
-!                                        surf_usm_v(l)%ddz_green_stag(nzb_wall,m)
+!              gtend(nzb_wall) = (1.0_wp / surf%rho_c_green(nzb_wall,m)) * &
+!                                      ( surf%lambda_h_green(nzb_wall,m) * &
+!                                        ( t_green%val(nzb_wall+1,m)             &
+!                                        - t_green%val(nzb_wall,m) ) *           &
+!                                        surf%ddz_green(nzb_wall+1,m)      &
+!                                      + surf%wghf_eb(m) ) *               &
+!                                        surf%ddz_green_stag(nzb_wall,m)
 !
 !              DO  kw = nzb_wall+1, nzt_wall
-!                 gtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_green(kw,m))          &
-!                           * (   surf_usm_v(l)%lambda_h_green(kw,m)              &
-!                             * ( t_green_v(l)%t(kw+1,m) - t_green_v(l)%t(kw,m) ) &
-!                             * surf_usm_v(l)%ddz_green(kw+1,m)                   &
-!                           - surf_usm_v(l)%lambda_h(kw-1,m)                      &
-!                             * ( t_green_v(l)%t(kw,m) - t_green_v(l)%t(kw-1,m) ) &
-!                             * surf_usm_v(l)%ddz_green(kw,m) )                   &
-!                           * surf_usm_v(l)%ddz_green_stag(kw,m)
+!                 gtend(kw) = (1.0_wp / surf%rho_c_green(kw,m))          &
+!                           * (   surf%lambda_h_green(kw,m)              &
+!                             * ( t_green%val(kw+1,m) - t_green%val(kw,m) ) &
+!                             * surf%ddz_green(kw+1,m)                   &
+!                           - surf%lambda_h(kw-1,m)                      &
+!                             * ( t_green%val(kw,m) - t_green%val(kw-1,m) ) &
+!                             * surf%ddz_green(kw,m) )                   &
+!                           * surf%ddz_green_stag(kw,m)
 !              ENDDO
 !
-!              t_green_v_p(l)%t(nzb_wall:nzt_wall,m) =                              &
-!                                   t_green_v(l)%t(nzb_wall:nzt_wall,m)             &
+!              t_green_v_p(l)%val(nzb_wall:nzt_wall,m) =                              &
+!                                   t_green%val(nzb_wall:nzt_wall,m)             &
 !                                 + dt_3d * ( tsc(2)                                &
 !                                 * gtend(nzb_wall:nzt_wall) + tsc(3)               &
-!                                 * surf_usm_v(l)%tt_green_m(nzb_wall:nzt_wall,m) )
+!                                 * surf%tt_green_m(nzb_wall:nzt_wall,m) )
 !
 ! !
@@ -5934,26 +5707,26 @@
 !                  IF ( intermediate_timestep_count == 1 )  THEN
 !                     DO  kw = nzb_wall, nzt_wall
-!                        surf_usm_v(l)%tt_green_m(kw,m) = gtend(kw)
+!                        surf%tt_green_m(kw,m) = gtend(kw)
 !                     ENDDO
 !                  ELSEIF ( intermediate_timestep_count <                           &
 !                           intermediate_timestep_count_max )  THEN
 !                      DO  kw = nzb_wall, nzt_wall
-!                         surf_usm_v(l)%tt_green_m(kw,m) =                          &
+!                         surf%tt_green_m(kw,m) =                          &
 !                                     - 9.5625_wp * gtend(kw) +                     &
-!                                       5.3125_wp * surf_usm_v(l)%tt_green_m(kw,m)
+!                                       5.3125_wp * surf%tt_green_m(kw,m)
 !                      ENDDO
 !                  ENDIF
 !              ENDIF
-
              DO  kw = nzb_wall, nzt_wall+1
-                 t_green_v(l)%t(kw,m) = t_wall_v(l)%t(nzb_wall,m)
+                 t_green%val(kw,m) = t_wall%val(nzb_wall,m)
              ENDDO
-
-          ENDIF
-
+          ENDIF
        ENDDO
-    ENDDO
-
-    IF ( debug_output_timestep )  CALL debug_message( 'usm_green_heat_model', 'end' )
+    ENDIF
+
+    IF ( debug_output_timestep )  THEN
+       WRITE( debug_string, * ) 'usm_green_heat_model: ', horizontal, l
+       CALL debug_message( debug_string, 'end' )
+    ENDIF
 
  END SUBROUTINE usm_green_heat_model
@@ -5972,8 +5745,4 @@
     NAMELIST /urban_surface_par/                                                                   &
                         building_type,                                                             &
-                        land_category,                                                             &
-                        naheatlayers,                                                              &
-                        pedestrian_category,                                                       &
-                        read_wall_temp_3d,                                                         &
                         roof_category,                                                             &
                         roof_inner_temperature,                                                    &
@@ -5981,6 +5750,4 @@
                         soil_inner_temperature,                                                    &
                         urban_surface,                                                             &
-                        usm_anthropogenic_heat,                                                    &
-                        usm_material_model,                                                        &
                         usm_wall_mod,                                                              &
                         wall_category,                                                             &
@@ -5991,8 +5758,4 @@
     NAMELIST /urban_surface_parameters/                                                            &
                         building_type,                                                             &
-                        land_category,                                                             &
-                        naheatlayers,                                                              &
-                        pedestrian_category,                                                       &
-                        read_wall_temp_3d,                                                         &
                         roof_category,                                                             &
                         roof_inner_temperature,                                                    &
@@ -6000,6 +5763,4 @@
                         soil_inner_temperature,                                                    &
                         urban_surface,                                                             &
-                        usm_anthropogenic_heat,                                                    &
-                        usm_material_model,                                                        &
                         usm_wall_mod,                                                              &
                         wall_category,                                                             &
@@ -6063,94 +5824,4 @@
 
  END SUBROUTINE usm_parin
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!
-!> This subroutine is part of the urban surface model.
-!> It reads daily heat produced by anthropogenic source and the diurnal cycle of the heat.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE usm_read_anthropogenic_heat
-
-    INTEGER(iwp)  ::  i, ii, j, k  !< running indices
-
-    REAL(wp)      ::  heat      !< anthropogenic heat
-
-!
-!-- Allocation of array of sources of anthropogenic heat and their diural profile
-    ALLOCATE( aheat(naheatlayers,nys:nyn,nxl:nxr) )
-    ALLOCATE( aheatprof(naheatlayers,0:24) )
-
-!
-!-- Read daily amount of heat and its daily cycle
-    aheat = 0.0_wp
-    DO  ii = 0, io_blocks-1
-        IF ( ii == io_group )  THEN
-
-!--         Open anthropogenic heat file
-            OPEN( 151, file = 'ANTHROPOGENIC_HEAT' // TRIM( coupling_char ), action = 'read',      &
-                  status = 'old', form = 'formatted', err = 11 )
-            i = 0
-            j = 0
-            DO
-                READ( 151, *, ERR=12, END=13 )  i, j, k, heat
-                IF ( i >= nxl  .AND.  i <= nxr  .AND.  j >= nys  .AND.  j <= nyn )  THEN
-                    IF ( k <= naheatlayers  .AND.  k > topo_top_ind(j,i,0) )  THEN
-!--                     Write heat into the array
-                        aheat(k,j,i) = heat
-                    ENDIF
-                ENDIF
-                CYCLE
- 12             WRITE( message_string, '(a,2i4)' ) 'error in file ANTHROPOGENIC_HEAT'              &
-                                                   // TRIM( coupling_char ) // ' after line ', i, j
-                CALL message( 'usm_read_anthropogenic_heat', 'PA0515', 0, 1, 0, 6, 0 )
-            ENDDO
- 13         CLOSE( 151 )
-            CYCLE
- 11         message_string = 'file ANTHROPOGENIC_HEAT' // TRIM( coupling_char ) // ' does not exist'
-            CALL message( 'usm_read_anthropogenic_heat', 'PA0516', 1, 2, 0, 6, 0 )
-        ENDIF
-
-#if defined( __parallel )
-        CALL MPI_BARRIER( comm2d, ierr )
-#endif
-    ENDDO
-
-!
-!-- Read diurnal profiles of heat sources
-    aheatprof = 0.0_wp
-    DO  ii = 0, io_blocks-1
-       IF ( ii == io_group )  THEN
-!
-!--         Open anthropogenic heat profile file
-            OPEN( 151, file = 'ANTHROPOGENIC_HEAT_PROFILE' // TRIM( coupling_char ),               &
-                  action = 'read', status = 'old', form = 'formatted', err = 21 )
-            i = 0
-            DO
-               READ( 151, *, err = 22, end = 23 )  i, k, heat
-!
-!--            Write heat into the array
-               IF ( i >= 0  .AND.  i <= 24  .AND.  k <= naheatlayers )  THEN
-                   aheatprof(k,i) = heat
-               ENDIF
-               CYCLE
- 22            WRITE( message_string, '(a,i4)' ) 'error in file ANTHROPOGENIC_HEAT_PROFILE' //     &
-                                                  TRIM( coupling_char ) // ' after line ', i
-               CALL message( 'usm_read_anthropogenic_heat', 'PA0517', 0, 1, 0, 6, 0 )
-            ENDDO
-            aheatprof(:,24) = aheatprof(:,0)
- 23         CLOSE( 151 )
-            CYCLE
- 21         message_string = 'file ANTHROPOGENIC_HEAT_PROFILE'//TRIM(coupling_char)//' does not exist'
-            CALL message( 'usm_read_anthropogenic_heat', 'PA0518', 1, 2, 0, 6, 0 )
-        ENDIF
-
-#if defined( __parallel )
-        CALL MPI_BARRIER( comm2d, ierr )
-#endif
-    ENDDO
-
- END SUBROUTINE usm_read_anthropogenic_heat
 
 
@@ -6173,5 +5844,4 @@
     INTEGER(iwp)  ::  k                 !< running index over previous input files covering current local domain
     INTEGER(iwp)  ::  l                 !< index variable for surface type
-    INTEGER(iwp)  ::  ns_h_on_file_usm  !< number of horizontal surface elements (urban type) on file
     INTEGER(iwp)  ::  nxlc              !< index of left boundary on current subdomain
     INTEGER(iwp)  ::  nxlf              !< index of left boundary on former subdomain
@@ -6184,4 +5854,5 @@
     INTEGER(iwp)  ::  nysf              !< index of south boundary on former subdomain
     INTEGER(iwp)  ::  nys_on_file       !< index of south boundary on former local domain
+    INTEGER(iwp)  ::  ns_h_on_file_usm(0:1)  !< number of horizontal surface elements (urban type) on file
     INTEGER(iwp)  ::  ns_v_on_file_usm(0:3)  !< number of vertical surface elements (urban type) on file
 !
@@ -6194,22 +5865,22 @@
 
 ! MS: Why are there individual temporary arrays that all have the same size?
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  tmp_surf_green_h   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  tmp_surf_mliq_h    !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  tmp_surf_wall_h    !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  tmp_surf_waste_h   !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  tmp_surf_window_h  !<
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  tmp_green_h   !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  tmp_wall_h    !<
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  tmp_window_h  !<
-
-    TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_green_v   !<
-    TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_wall_v    !<
-    TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_waste_v   !<
-    TYPE( t_surf_vertical ), DIMENSION(0:3), SAVE ::  tmp_surf_window_v  !<
-
-    TYPE( t_wall_vertical ), DIMENSION(0:3), SAVE ::  tmp_green_v   !<
-    TYPE( t_wall_vertical ), DIMENSION(0:3), SAVE ::  tmp_wall_v    !<
-    TYPE( t_wall_vertical ), DIMENSION(0:3), SAVE ::  tmp_window_v  !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:1), SAVE ::  tmp_surf_green_h   !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:1), SAVE ::  tmp_surf_mliq_h    !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:1), SAVE ::  tmp_surf_wall_h    !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:1), SAVE ::  tmp_surf_waste_h   !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:1), SAVE ::  tmp_surf_window_h  !<
+
+    TYPE( surf_type_2d_usm ), DIMENSION(0:1), SAVE ::  tmp_green_h   !<
+    TYPE( surf_type_2d_usm ), DIMENSION(0:1), SAVE ::  tmp_wall_h    !<
+    TYPE( surf_type_2d_usm ), DIMENSION(0:1), SAVE ::  tmp_window_h  !<
+
+    TYPE( surf_type_1d_usm ), DIMENSION(0:3), SAVE ::  tmp_surf_green_v   !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:3), SAVE ::  tmp_surf_wall_v    !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:3), SAVE ::  tmp_surf_waste_v   !<
+    TYPE( surf_type_1d_usm ), DIMENSION(0:3), SAVE ::  tmp_surf_window_v  !<
+
+    TYPE( surf_type_2d_usm ), DIMENSION(0:3), SAVE ::  tmp_green_v   !<
+    TYPE( surf_type_2d_usm ), DIMENSION(0:3), SAVE ::  tmp_wall_v    !<
+    TYPE( surf_type_2d_usm ), DIMENSION(0:3), SAVE ::  tmp_window_v  !<
 
 
@@ -6223,12 +5894,14 @@
              READ ( 13 ) ns_h_on_file_usm
 
-             IF ( ALLOCATED( tmp_surf_wall_h ) )    DEALLOCATE( tmp_surf_wall_h )
-             IF ( ALLOCATED( tmp_wall_h ) )         DEALLOCATE( tmp_wall_h )
-             IF ( ALLOCATED( tmp_surf_window_h ) )  DEALLOCATE( tmp_surf_window_h )
-             IF ( ALLOCATED( tmp_window_h) )        DEALLOCATE( tmp_window_h )
-             IF ( ALLOCATED( tmp_surf_green_h) )    DEALLOCATE( tmp_surf_green_h )
-             IF ( ALLOCATED( tmp_green_h) )         DEALLOCATE( tmp_green_h )
-             IF ( ALLOCATED( tmp_surf_mliq_h) )     DEALLOCATE( tmp_surf_mliq_h )
-             IF ( ALLOCATED( tmp_surf_waste_h) )    DEALLOCATE( tmp_surf_waste_h )
+             DO  l = 0, 1
+                IF ( ALLOCATED( tmp_surf_wall_h(l)%val ) )    DEALLOCATE( tmp_surf_wall_h(l)%val )
+                IF ( ALLOCATED( tmp_wall_h(l)%val ) )         DEALLOCATE( tmp_wall_h(l)%val )
+                IF ( ALLOCATED( tmp_surf_window_h(l)%val ) )  DEALLOCATE( tmp_surf_window_h(l)%val )
+                IF ( ALLOCATED( tmp_window_h(l)%val) )        DEALLOCATE( tmp_window_h(l)%val )
+                IF ( ALLOCATED( tmp_surf_green_h(l)%val) )    DEALLOCATE( tmp_surf_green_h(l)%val )
+                IF ( ALLOCATED( tmp_green_h(l)%val) )         DEALLOCATE( tmp_green_h(l)%val )
+                IF ( ALLOCATED( tmp_surf_mliq_h(l)%val) )     DEALLOCATE( tmp_surf_mliq_h(l)%val )
+                IF ( ALLOCATED( tmp_surf_waste_h(l)%val) )    DEALLOCATE( tmp_surf_waste_h(l)%val )
+             ENDDO
 
 !
@@ -6236,12 +5909,14 @@
 !--          elements do not necessarily need  to match the size of present surface elements on
 !--          current processor, as the number of processors between restarts can change.
-             ALLOCATE( tmp_surf_wall_h(1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_wall_h(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_surf_window_h(1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_window_h(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_surf_green_h(1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_green_h(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_surf_mliq_h(1:ns_h_on_file_usm) )
-             ALLOCATE( tmp_surf_waste_h(1:ns_h_on_file_usm) )
+             DO  l = 0, 1
+                ALLOCATE( tmp_surf_wall_h(l)%val(1:ns_h_on_file_usm(l)) )
+                ALLOCATE( tmp_wall_h(l)%val(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_window_h(l)%val(1:ns_h_on_file_usm(l)) )
+                ALLOCATE( tmp_window_h(l)%val(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_green_h(l)%val(1:ns_h_on_file_usm(l)) )
+                ALLOCATE( tmp_green_h(l)%val(nzb_wall:nzt_wall+1, 1:ns_h_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_mliq_h(l)%val(1:ns_h_on_file_usm(l)) )
+                ALLOCATE( tmp_surf_waste_h(l)%val(1:ns_h_on_file_usm(l)) )
+             ENDDO
 
           ENDIF
@@ -6252,11 +5927,11 @@
 
              DO  l = 0, 3
-                IF ( ALLOCATED( tmp_surf_wall_v(l)%t ) )    DEALLOCATE( tmp_surf_wall_v(l)%t )
-                IF ( ALLOCATED( tmp_wall_v(l)%t ) )         DEALLOCATE( tmp_wall_v(l)%t )
-                IF ( ALLOCATED( tmp_surf_window_v(l)%t ) )  DEALLOCATE( tmp_surf_window_v(l)%t )
-                IF ( ALLOCATED( tmp_window_v(l)%t ) )       DEALLOCATE( tmp_window_v(l)%t )
-                IF ( ALLOCATED( tmp_surf_green_v(l)%t ) )   DEALLOCATE( tmp_surf_green_v(l)%t )
-                IF ( ALLOCATED( tmp_green_v(l)%t ) )        DEALLOCATE( tmp_green_v(l)%t )
-                IF ( ALLOCATED( tmp_surf_waste_v(l)%t ) )   DEALLOCATE( tmp_surf_waste_v(l)%t )
+                IF ( ALLOCATED( tmp_surf_wall_v(l)%val ) )    DEALLOCATE( tmp_surf_wall_v(l)%val )
+                IF ( ALLOCATED( tmp_wall_v(l)%val ) )         DEALLOCATE( tmp_wall_v(l)%val )
+                IF ( ALLOCATED( tmp_surf_window_v(l)%val ) )  DEALLOCATE( tmp_surf_window_v(l)%val )
+                IF ( ALLOCATED( tmp_window_v(l)%val ) )       DEALLOCATE( tmp_window_v(l)%val )
+                IF ( ALLOCATED( tmp_surf_green_v(l)%val ) )   DEALLOCATE( tmp_surf_green_v(l)%val )
+                IF ( ALLOCATED( tmp_green_v(l)%val ) )        DEALLOCATE( tmp_green_v(l)%val )
+                IF ( ALLOCATED( tmp_surf_waste_v(l)%val ) )   DEALLOCATE( tmp_surf_waste_v(l)%val )
              ENDDO
 
@@ -6266,11 +5941,11 @@
 !--          current processor, as the number of processors between restarts can change.
              DO  l = 0, 3
-                ALLOCATE( tmp_surf_wall_v(l)%t(1:ns_v_on_file_usm(l)) )
-                ALLOCATE( tmp_wall_v(l)%t(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
-                ALLOCATE( tmp_surf_window_v(l)%t(1:ns_v_on_file_usm(l)) )
-                ALLOCATE( tmp_window_v(l)%t(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
-                ALLOCATE( tmp_surf_green_v(l)%t(1:ns_v_on_file_usm(l)) )
-                ALLOCATE( tmp_green_v(l)%t(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
-                ALLOCATE( tmp_surf_waste_v(l)%t(1:ns_v_on_file_usm(l)) )
+                ALLOCATE( tmp_surf_wall_v(l)%val(1:ns_v_on_file_usm(l)) )
+                ALLOCATE( tmp_wall_v(l)%val(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_window_v(l)%val(1:ns_v_on_file_usm(l)) )
+                ALLOCATE( tmp_window_v(l)%val(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_green_v(l)%val(1:ns_v_on_file_usm(l)) )
+                ALLOCATE( tmp_green_v(l)%val(nzb_wall:nzt_wall+1, 1:ns_v_on_file_usm(l) ) )
+                ALLOCATE( tmp_surf_waste_v(l)%val(1:ns_v_on_file_usm(l)) )
              ENDDO
 
